/*  $Id: frame.cpp,v 1.31 2003/09/18 17:53:29 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "precomp.h"
#include "API/GUI/frame.h"
#include "API/GUI/stylemanager.h"
#include "API/Core/XML/dom_element.h"
#include "frame_generic.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_Frame::CL_Frame(
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(parent, style), impl(NULL)
{
	impl = new CL_Frame_Generic(this);
	get_style_manager()->connect_styles("frame", this);
	find_preferred_size();
}

CL_Frame::CL_Frame(
	const CL_Rect &pos,
	CL_Component *parent,
	CL_StyleManager *style)
: CL_Component(pos, parent, style), impl(NULL)
{
	impl = new CL_Frame_Generic(this);
	get_style_manager()->connect_styles("frame", this);
}

CL_Frame::~CL_Frame()
{
	delete impl;
}

/////////////////////////////////////////////////////////////////////////////
// Attributes:

bool CL_Frame::is_fill_enabled() const
{
	return impl->fill;
}

/////////////////////////////////////////////////////////////////////////////
// Operations:

void CL_Frame::enable_fill(bool enabled)
{
	impl->fill = enabled;
}

